/**
 * Created by root on 22.03.14.
 */

var utils = require("./index");
var events = require("events");



var TestSubject = utils.oo.Class(utils.pattern.Subject, null, function Test()
{

});
var TestObserver = utils.oo.Class(null, utils.pattern.IObserver, function Test()
{
    this.update = function(target, event)
    {
        console.log(target, event)
    }
});


var testS = new TestSubject();
var testO = new TestObserver();

var emitter = new events.EventEmitter();


var _eventsList = ["test"];
var times = 10000000;

var timesLi = 0;



var li = [];
function getList ()
{
    if(!(timesLi++%2))
    {
        console.log("Time " + (timesLi-1)/2);
        li.push(timesLi.toString());
    }
    return li;
}


//testA();
var b = function(f)
{
    return function()
    {
        console.log("B" + arguments[0])
        f()
    }
};
var a = utils.decorate([b],function()
{
    console.log("A");
});
a(1);

function testA()
{
    var eventsList = getList();

    var counter = 0;
    var time = Date.now();
    var len = eventsList.length;
    for(var i = 0 ; i < len; i++)
    {
        emitter.on(eventsList[i],function()
        {
            if(++counter == times)
            {

                console.log(Date.now()-time);
                testB();
            }
        });
    }
    for(i = 0 ; i < times; i++)
    {
        var tmp = eventsList.shift();
        eventsList.push(tmp);

        emitter.emit(tmp);
    }

}

function testB()
{
    var eventsList = getList();

    testS.subscribe(testO);
    testO.update = function(target,event)
    {
        var len = eventsList.length;
        for(var i = 0; i < len; i++)
        {
            if(eventsList[i] == event)
            {
                if(++counter == times)
                {
                    console.log(Date.now()-time);
                    testA();
                }
            }
        }
    };
    var time = Date.now();
    var counter = 0;
    for(var i = 0 ; i < times; i++)
    {
        var tmp = eventsList.shift();
        eventsList.push(tmp);
        testS.notify(tmp);
    }
}